;Alien Shooter!

	;文字型変数bfにファイル内容を読込み
	sdim bf,64000 :bload "chr.bin",bf

*start
	title "Alien Shooter!"
	color 8,0,0 :boxf 0,0,640,480
	cno=5 :x1=320 :y1=240 :sz=30 :gosub *chrput
	;Beep Music
	ms="H3D6E3H3D6E3H2H1H3F3E1F1H3D3C1E1D5" :gosub *bgm

x=320 :y=440	;自機の座標
hp=3			;自機の耐久力
bmx=5			;弾の総数
emx=1			;敵の総数
sc=0			;得点
bs=0			;ボーナス得点
i=0				;弾の使用No.
ov=0			;ゲームオーバーフラグ

;弾座標用配列変数(16個まではdim宣言不要)
repeat bmx :by(cnt)=-99 :loop

;敵座標用配列変数(16個まではdim宣言不要)
repeat 16 :ey(cnt)=500 :loop

;地面用配列変数(80個使うのでdim宣言)
dim fl,80
repeat 80 :fl(cnt)=1 :loop
fl(0)=0 :fl(79)=0
 
;町ビル(背景)用配列変数
dim bix,8 :dim biy,8
repeat 8 :bix(cnt)=50+8*rnd(5) :biy(cnt)=200+16*rnd(10) :loop

repeat 
	redraw 0

	;全画面消去
	color 0,0,8 :boxf 0,0,639,479

	;町ビルを描く  
	color 0,32,32
	repeat 8
		boxf 80*cnt,biy(cnt),80*cnt+bix(cnt),450
	loop

	;地面を描く(変数flの内容が0の部分は描かない)
	color 160,160,160
	repeat 80
		if fl(cnt)=1 :boxf cnt*8,455,cnt*8+7,460
	loop

	stick key   

	;自機移動(変数flの内容が0なら移動できない)
	if key&1 {
		if fl(x/8-1)!0 :x=x-8
	}
	if key&4 {
		if fl(x/8+1)!0 :x=x+8
	}
	cno=4 :x1=x :y1=y :sz=2 :gosub *chrput

	;弾発射(初期座標を設定)
	if (key&16)>0 and by(i)<0 {
		beep 800,20
		bx(i)=x :by(i)=y :i=(i+1)\bmx
	}
	;弾移動(移動と表示)
	repeat bmx :c=cnt
		if by(c)>=0 {
			by(c)=by(c)-28
			color 250,200,0 :boxf bx(c)-1,by(c)-8,bx(c)+1,by(c)+8
		}
	loop

	;敵発生(初期座標を設定)
	r=rnd(16)
	if ey(r)>480 and r<emx :ex(r)=rnd(640) :ey(r)=-8

	;敵の移動量を設定
	dx(r)=rnd(64)-32 :dy(r)=rnd(4)+3

	;敵移動(敵座標＋移動量)
	repeat 16 :c=cnt
		if ey(c)<=480 {
			ex(c)=ex(c)+dx(c) :ey(c)=ey(c)+dy(c)
			cno=5 :x1=ex(c) :y1=ey(c) :sz=2 :gosub *chrput
			xx=ex(c)/8
			if ey(c)>460 and xx>=0 and xx<80 {
				fl(xx)=0 :ey(c)=500
			}
		}
	dx(c)=dx(c)*5/6
	loop

	;爆発中
	if oc>0 :gosub *bom

	redraw 1

	;当たり判定(敵と弾)
	repeat bmx :bc=cnt
		repeat emx :ec=cnt

			ebc=abs(ex(ec)-bx(bc))
			if ebc<20 and abs(ey(ec)-by(bc))<16 {
				oc=5 :ox=ex(ec) :oy=ey(ec) :by(bc)=-99 :ey(ec)=500
				sc=sc+1 :bs=bs+2*(ebc<3) :title "SCORE:"+100*(sc+bs)
				emx=sc/9+1 :if emx>15 :emx=15
			}

		loop
	loop

	;当たり判定(敵と自機)
	repeat emx
		if abs(ex(cnt)-x)<20 and abs(ey(cnt)-y)<10 {
			oc=5 :ox=ex(ec) :oy=ey(ec)
			hp=hp-1 :ey(cnt)=500 :title "HP:"+hp
			if hp<1 :ov=1
		}
	loop
	if ov=1 :break

	wait 3
loop

	title "GAME OVER. YOUR SCORE:"+100*(sc+bs)
	beep 440,600,4
*owari
	wait 1 :stick k
	if (k&272)>0 :goto *start
	goto *owari

;爆発表示
*bom
	beep 250,20 :color 250,0,0
	repeat oc*10
		rx=rnd(50)-25 :ry=rnd(40)-20
		pset ox+rx,oy+ry
	loop
	oc=oc-1
	return

;キャラクター表示ルーチン
*chrput
	xs=peek(bf,0) :m=xs*(xs/7) :cln=m*2+8 :adr=cno*cln

	;RGB色情報ゲット
	repeat 3
		a=peek(bf,adr+1+cnt)&63
		r(cnt)=80*(a/16)+15 :g(cnt)=80*((a&12)/4)+15 :b(cnt)=80*(a&3)+15
	loop

	;キャラクタービット計算＆表示
	j=0
	repeat m
		c1=peek(bf,adr+4+cnt) :c2=peek(bf,adr+4+m+cnt)
		a=64
		repeat 7
			xx=x1-(xs*sz/2)+(j\xs)*sz :yy=y1-(xs*sz/2)+(j/xs)*sz
			c3=((c1&a)>0)+2*((c2&a)>0)
			if c3>0 {
				color r(c3-1),g(c3-1),b(c3-1)
				boxf xx,yy,xx+sz-1,yy+sz-1
			}
			a=a/2 :j=j+1
		loop
	loop
	return

;Beep演奏ルーチン
*bgm
	dim qp,8
	qp(0)=440	;A(ド)
	qp(1)=494	;B(レ)
	qp(2)=554	;C(ミ)
	qp(3)=587	;D(ファ)
	qp(4)=659	;E(ソ)
	qp(5)=740	;F(ラ)
	qp(6)=830	;G(シ)
	qp(7)=880	;H(ド)
	i=0
	repeat
		n=peek(ms,i)-65 :m=peek(ms,i+1)-48
		if n<0 or m<0 :break
		beep qp(n),100*m :i=i+2
	loop
	return
